C*****************************************
       program find triple junctions
C*****************************************
       implicit none
	   
	   integer CD
	   parameter (CD=11600)
	   real e1, e2, temp, value1, value2, tri, s
	   real tj_1, tj_2
	   real xi1, xf1, yi1, yf1, xi2, xf2, yi2, yf2
	   integer match, i, j, nnline, change, ii, start, trips
	   integer kk, ll, indx, header, hash
	   integer file_n, first, last, msf, lsf
	   character*1 one
	   character*1 two
	   character*8 keyword
	   character*40 tempword
	   character*100 inline	   
	   
	   dimension e1(3), e2(3), tri(12,3), s(14,CD)
	   dimension tj_1(10000,5), tj_2(10000,5)
	   
       write(6,*) '=============================================='
	   write(6,*) ' PROGRAM SEARCHES LISTS OF LINE SEGMENTS'
	   write(6,*) ' TO FIND TRIPLETS THAT MEET AT A POINT, '
	   write(6,*) ' AND THE WRITES AN ORDERED LIST TO A FILE '	   
	   write(6,*)
	   write(6,*) ' DEEVELOPED BY CMU MRSEC'
	   write(6,*) '  version 11/05/09'
       write(6,*) '=============================================='
	     
	! compile with gfortran find_tjs.f -o find_tjs
	 

       open(21, file='input.txt', status='old')
       read(21,*) keyword
       read(21,*) first
	   read(21,*) last
       close(21)
  
       do file_n=first,last
c       Start by opeing a file and determining the total number of lines in the data file   
	   if (file_n.eq.0) then
	    one=char(48)
		open (32, file=keyword//'_00'//one//'.txt'
     &         ,status='unknown')
		goto 8
	   endif
	   
	   if (file_n.gt.0.and.file_n.lt.10) then
	    one=char(48+file_n)
		open (32, file=keyword//'_00'//one//'.txt'
     &         ,status='unknown')
	    goto 8
	   endif	
		
	   if (file_n.gt.9.and.file_n.lt.100) then
	    msf=int(file_n/10)
		lsf=file_n-(10*msf)
		one=char(48+msf)
		two=char(48+lsf)
		open (32, file=keyword//'_0'//one//two//'.txt'
     &         ,status='unknown')
	    goto 8
	   endif
 
 8     continue	 

		nnline = 0

 10     continue
		read(32,*,end=11)
		nnline=nnline+1
		goto 10
 11     continue
        close(32)
		
 12    	format(A,I7,A,I3,A)
 
c       Open again and determine the length of the header   
 
 	   if (file_n.eq.0) then
	    one=char(48)
		open (32, file=keyword//'_00'//one//'.txt'
     &         ,status='unknown')
		goto 13
	   endif
	   
	   if (file_n.gt.0.and.file_n.lt.10) then
	    one=char(48+file_n)
		open (32, file=keyword//'_00'//one//'.txt'
     &         ,status='unknown')
	    goto 13
	   endif	
		
	   if (file_n.gt.9.and.file_n.lt.100) then
	    msf=int(file_n/10)
		lsf=file_n-(10*msf)
		one=char(48+msf)
		two=char(48+lsf)
		open (32, file=keyword//'_0'//one//two//'.txt'
     &         ,status='unknown')
	    goto 13
	   endif
 
13     continue	 

 
 
c Check each line for the string '#'. If found, we know this line is part  
c of the header.  If not, we have reached the data section.		

       header = 0
       hash = 0
	   do i=1,nnline
	    read(32, "(a)") inline
	    hash = index(inline, '#')
	    if (hash.ne.0) then
	     header=header+1
		 hash=0
	    else
		 goto 14     
	    endif			
	   enddo
 14   close(32)		

	  write(6,12)'There are',nnline,' lines in file',file_n,'.'

        if (nnline.gt.CD) then 
          write(6,*)'you need to increase the size of the s array.  Bye'
          goto 9020
		endif  



	   if (file_n.eq.0) then
	    one=char(48)
		open (32, file=keyword//'_00'//one//'.txt'
     &         ,status='unknown')
		open (33, file='triples'//'_00'//one//'.txt'
     &         ,status='unknown')
		goto 18
	   endif
	   
	   if (file_n.gt.0.and.file_n.lt.10) then
	    one=char(48+file_n)
		open (32, file=keyword//'_00'//one//'.txt'
     &         ,status='unknown')
		open (33, file='triples'//'_00'//one//'.txt'
     &         ,status='unknown')	
	    goto 18
	   endif	
		
	   if (file_n.gt.9.and.file_n.lt.100) then
	    msf=int(file_n/10)
		lsf=file_n-(10*msf)
		one=char(48+msf)
		two=char(48+lsf)
		open (32, file=keyword//'_0'//one//two//'.txt'
     &         ,status='unknown')
		open (33, file='triples'//'_0'//one//two//'.txt'
     &         ,status='unknown')	 
	    goto 18
	   endif
 
 18     continue	 



c   Read the data into the segment matrix

c  read the header
        do i=1,header
	     read(32, "(a)") inline
		 write(33,"(a)") inline
	    enddo

		do i=1,nnline-header
		 read(32,*,end=21) s(1,i), s(2,i), s(3,i), s(4,i), s(5,i), 		
     &	 s(6,i), s(7,i), s(8,i), s(9,i), s(10,i), s(11,i), s(12,i),
     &   s(13,i), s(14,i)
		enddo
 21     continue		
		close (32)

c  The next big section of code find all the triple junctions, but it finds
c  most of them more then once, so they have to be sorted.  At this stage,
c  the number of line segments involved and the x,y coordinates are saved in
c  the matrix t

		trips=0
		do i=1,nnline
		 match=0
		 start=0
		 do j=1,nnline
		  if (j.eq.i) goto 40
		  if(match.eq.1) goto 30
c  this is the section where you find the first match		  
          if(s(9,i).eq.s(9,j).and.s(10,i).eq.s(10,j)) then
		   match=match+1
		   start=1
		   if(match.eq.1) temp=j
		   goto 40
		  endif
          if(s(9,i).eq.s(11,j).and.s(10,i).eq.s(12,j)) then
		   match=match+1
		   start=1
		   if(match.eq.1) temp=j
		   goto 40
		  endif
          if(s(11,i).eq.s(9,j).and.s(12,i).eq.s(10,j)) then
		   match=match+1
		   start=2
		   if(match.eq.1) temp=j
		   goto 40
		  endif
          if(s(11,i).eq.s(11,j).and.s(12,i).eq.s(12,j)) then
		   match=match+1
		   start=2
		   if(match.eq.1) temp=j
		   goto 40
		  endif
		  goto 40
c if you already have the first match, you come here		  
 30       continue		  
c         this is if the first match was on the first coordinate		  
		  if (start.eq.1) then
		   if(s(9,i).eq.s(9,j).and.s(10,i).eq.s(10,j)) then
		   	trips=trips+1
			tj_1(trips,1)=i
			tj_1(trips,2)=temp
		    tj_1(trips,3)=j
		    tj_1(trips,4)=s(9,i)
		    tj_1(trips,5)=s(10,i)		
			goto 60   
		   endif
		   if(s(9,i).eq.s(11,j).and.s(10,i).eq.s(12,j)) then
		   	trips=trips+1
			tj_1(trips,1)=i
			tj_1(trips,2)=temp
		    tj_1(trips,3)=j
		    tj_1(trips,4)=s(9,i)
		    tj_1(trips,5)=s(10,i)		
			goto 60 
		   endif
		  endif
c         this is if the first match was on the second coordinate			  
		  if (start.eq.2) then
		   if(s(11,i).eq.s(9,j).and.s(12,i).eq.s(10,j)) then
			trips=trips+1
			tj_1(trips,1)=i
			tj_1(trips,2)=temp
		    tj_1(trips,3)=j
		    tj_1(trips,4)=s(11,i)
		    tj_1(trips,5)=s(12,i)
			goto 60
		   endif
		   if(s(11,i).eq.s(11,j).and.s(12,i).eq.s(12,j)) then
			trips=trips+1
			tj_1(trips,1)=i
			tj_1(trips,2)=temp
		    tj_1(trips,3)=j
		    tj_1(trips,4)=s(11,i)
		    tj_1(trips,5)=s(12,i)
			goto 60
		   endif
		  endif
		  
 40       continue	
        enddo		
        if(match.ne.2) goto 70

c       if you found the second match, you end up here
 60     continue
c 			write(33,100) float(trips),tj_1(trips,1),tj_1(trips,2),
c     &      tj_1(trips,3),tj_1(trips,4),tj_1(trips,5)
c	        write(34,*)tj_1(trips,4)
c	        write(35,*)tj_1(trips,5)
			
 70    continue			
       enddo
       
 100   format(6F7.2)

c       this take all the tjs in tj_1, eliminated duplicates, and puts the new
c       list in to tj_2

       tj_2(1,1)=tj_1(1,1)
       tj_2(1,2)=tj_1(1,2)
       tj_2(1,3)=tj_1(1,3)	   
       tj_2(1,4)=tj_1(1,4)
       tj_2(1,5)=tj_1(1,5)	   		  
       ii=1
c	   write(34,100) float(ii),tj_2(ii,1),tj_2(ii,2),
c     &      tj_2(ii,3),tj_2(ii,4),tj_2(ii,5)
       do kk=2,trips
	    do ll=1,ii
		 if (tj_1(kk,4).eq.tj_2(ll,4).and.tj_1(kk,5).eq.tj_2(ll,5)) then
           goto 200
	     endif
		enddo
		 ii=ii+1
		 tj_2(ii,1)=tj_1(kk,1)
         tj_2(ii,2)=tj_1(kk,2)
         tj_2(ii,3)=tj_1(kk,3)	   
         tj_2(ii,4)=tj_1(kk,4)
         tj_2(ii,5)=tj_1(kk,5)
c		 write(34,100) float(ii),tj_2(ii,1),tj_2(ii,2),
c     &      tj_2(ii,3),tj_2(ii,4),tj_2(ii,5)
c		write(35,*)tj_2(ii,4)
c		write(36,*)tj_2(ii,5)
 200    continue		
	   enddo	
 250     format(7f9.3,f8.2,4f11.2)
c        The next step is to write out all of the data
         do i=1,ii
		  indx=int(tj_2(i,1))
		write(33,250)s(1,indx),s(2,indx),s(3,indx),s(4,indx),
     &	s(5,indx),s(6,indx),s(7,indx),s(8,indx),s(9,indx),
     &	s(10,indx),s(11,indx),s(12,indx)
		  indx=int(tj_2(i,2))
		write(33,250)s(1,indx),s(2,indx),s(3,indx),s(4,indx),
     &	s(5,indx),s(6,indx),s(7,indx),s(8,indx),s(9,indx),
     &	s(10,indx),s(11,indx),s(12,indx)	 
		  indx=int(tj_2(i,3))
		write(33,250)s(1,indx),s(2,indx),s(3,indx),s(4,indx),
     &	s(5,indx),s(6,indx),s(7,indx),s(8,indx),s(9,indx),
     &	s(10,indx),s(11,indx),s(12,indx)	 	 
          enddo

 9000  continue
 
       close(32)
	   close(33) 
c	   close(34) 
c	   close(35) 
c	   close(36) 
	   	   	   	   
 9010  format(A,I5,A)	   

	    write(6,9010)'I found:',ii,' triple junctions.'
		
		enddo
	   
 9020  continue	   
       end